Index: /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 1287)
@@ -51,5 +51,5 @@
 }
 
-Void TComUpsampleFilter::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+Void TComUpsampleFilter::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Int refBitDepthLuma, const Int refBitDepthChroma )
 {
   assert ( NTAPS_US_LUMA == 8 );
@@ -63,4 +63,7 @@
   const Window &scalEL = currSlice->getPPS()->getScaledRefLayerWindowForLayer(refLayerId);
   const Window &windowRL = currSlice->getPPS()->getRefLayerWindowForLayer(refLayerId);
+
+  Int bitDepthLuma = currSlice->getBitDepth(CHANNEL_TYPE_LUMA);
+  Int bitDepthChroma = currSlice->getBitDepth(CHANNEL_TYPE_CHROMA);
 
   //========== Y component upsampling ===========
@@ -115,10 +118,10 @@
     piDstY = piDstBufY + scalEL.getWindowLeftOffset() + scalEL.getWindowTopOffset() * strideEL;
 
-    Int shift = g_bitDepthLayer[CHANNEL_TYPE_LUMA][currLayerId] - g_bitDepthLayer[CHANNEL_TYPE_LUMA][refLayerId];
+    Int shift = bitDepthLuma - refBitDepthLuma;
 
 #if CGS_3D_ASYMLUT
     if( currSlice->getPPS()->getCGSFlag() )
     {
-      shift = g_bitDepthLayer[CHANNEL_TYPE_LUMA][currLayerId] - currSlice->getPPS()->getCGSOutputBitDepthY();
+      shift = bitDepthLuma - currSlice->getPPS()->getCGSOutputBitDepthY();
     }
     assert( shift >= 0 );
@@ -151,10 +154,10 @@
     piDstV = piDstBufV + ( scalEL.getWindowLeftOffset() >> 1 ) + ( scalEL.getWindowTopOffset() >> 1 ) * strideEL;
 
-    shift = g_bitDepthLayer[CHANNEL_TYPE_CHROMA][currLayerId] - g_bitDepthLayer[CHANNEL_TYPE_CHROMA][refLayerId];
+    shift = bitDepthChroma - refBitDepthChroma;
 
 #if CGS_3D_ASYMLUT
     if( currSlice->getPPS()->getCGSFlag() )
     {
-      shift = g_bitDepthLayer[CHANNEL_TYPE_CHROMA][currLayerId] - currSlice->getPPS()->getCGSOutputBitDepthC();
+      shift = currSlice->getBitDepth(CHANNEL_TYPE_CHROMA) - currSlice->getPPS()->getCGSOutputBitDepthC();
     }
 #endif
@@ -218,5 +221,5 @@
 
     // g_bitDepthY was set to EL bit-depth, but shift1 should be calculated using BL bit-depth
-    Int shift1 = g_bitDepthLayer[CHANNEL_TYPE_LUMA][refLayerId] - 8;
+    Int shift1 = refBitDepthLuma - 8;
 
 #if CGS_3D_ASYMLUT
@@ -254,5 +257,5 @@
     pcTempPic->setHeight(heightEL);
 
-    Int nShift = 20 - g_bitDepthLayer[CHANNEL_TYPE_LUMA][currLayerId];
+    Int nShift = 20 - bitDepthLuma;
     Int iOffset = 1 << (nShift - 1);
 
@@ -273,5 +276,5 @@
       for( i = pcTempPic->getWidth(COMPONENT_Y); i > 0; i-- )
       {
-        *piDstY = Clip( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift), CHANNEL_TYPE_LUMA );
+        *piDstY = ClipBD( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift), bitDepthLuma );
         piSrcY++;
         piDstY++;
@@ -318,5 +321,5 @@
 
     // g_bitDepthC was set to EL bit-depth, but shift1 should be calculated using BL bit-depth
-    shift1 = g_bitDepthLayer[CHANNEL_TYPE_CHROMA][refLayerId] - 8;
+    shift1 = refBitDepthChroma - 8;
 
 #if CGS_3D_ASYMLUT
@@ -360,5 +363,5 @@
     pcTempPic->setHeight(heightEL << 1);
 
-    nShift = 20 - g_bitDepthLayer[CHANNEL_TYPE_CHROMA][currLayerId];
+    nShift = 20 - bitDepthChroma;
 
     iOffset = 1 << (nShift - 1);
@@ -384,6 +387,6 @@
       for( i = pcTempPic->getWidth(COMPONENT_Y) >> 1; i > 0; i-- )
       {
-        *piDstU = Clip( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift), CHANNEL_TYPE_CHROMA );
-        *piDstV = Clip( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift), CHANNEL_TYPE_CHROMA );
+        *piDstU = ClipBD( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift), bitDepthChroma );
+        *piDstV = ClipBD( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift), bitDepthChroma );
         piSrcU++;
         piSrcV++;
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 1287)
@@ -42,5 +42,5 @@
   TComUpsampleFilter(void);
   ~TComUpsampleFilter(void);
-  Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+  Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Int refBitDepthLuma, const Int refBitDepthChroma );
 
 };
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1287)
@@ -67,4 +67,5 @@
 Void TComWeightPrediction::addWeightBi( const TComYuv              *pcYuvSrc0,
                                         const TComYuv              *pcYuvSrc1,
+                                        const BitDepths            &bitDepths,
                                         const UInt                  iPartUnitIdx,
                                         const UInt                  uiWidth,
@@ -73,5 +74,5 @@
                                         const WPScalingParam *const wp1,
                                               TComYuv        *const rpcYuvDst,
-                                        const Bool                  bRoundLuma )
+                                        const Bool                  bRoundLuma)
 {
 
@@ -91,5 +92,5 @@
     const Int  w0          = wp0[compID].w;
     const Int  offset      = wp0[compID].offset;
-    const Int  clipBD      = g_bitDepth[toChannelType(compID)];
+    const Int  clipBD      = bitDepths.recon[toChannelType(compID)];
     const Int  shiftNum    = std::max<Int>(2, (IF_INTERNAL_PREC - clipBD));
     const Int  shift       = wp0[compID].shift + shiftNum;
@@ -131,4 +132,5 @@
 //! weighted averaging for uni-pred
 Void TComWeightPrediction::addWeightUni( const TComYuv        *const pcYuvSrc0,
+                                         const BitDepths            &bitDepths,
                                          const UInt                  iPartUnitIdx,
                                          const UInt                  uiWidth,
@@ -149,5 +151,5 @@
     const Int  w0          = wp0[compID].w;
     const Int  offset      = wp0[compID].offset;
-    const Int  clipBD      = g_bitDepth[toChannelType(compID)];
+    const Int  clipBD      = bitDepths.recon[toChannelType(compID)];
     const Int  shiftNum    = std::max<Int>(2, (IF_INTERNAL_PREC - clipBD));
     const Int  shift       = wp0[compID].shift + shiftNum;
@@ -230,5 +232,9 @@
     for ( Int yuv=0 ; yuv<numValidComponent ; yuv++ )
     {
-      const Int bitDepth            = g_bitDepth[toChannelType(ComponentID(yuv))];
+#if SVC_EXTENSION
+      const Int bitDepth            = pcSlice->getBitDepth(toChannelType(ComponentID(yuv)));
+#else
+      const Int bitDepth            = pcSlice->getSPS()->getBitDepth(toChannelType(ComponentID(yuv)));
+#endif
       const Int offsetScalingFactor = bUseHighPrecisionPredictionWeighting ? 1 : (1 << (bitDepth-8));
 
@@ -251,5 +257,9 @@
     for ( Int yuv=0 ; yuv<numValidComponent ; yuv++ )
     {
-      const Int bitDepth            = g_bitDepth[toChannelType(ComponentID(yuv))];
+#if SVC_EXTENSION
+      const Int bitDepth            = pcSlice->getBitDepth(toChannelType(ComponentID(yuv)));
+#else
+      const Int bitDepth            = pcSlice->getSPS()->getBitDepth(toChannelType(ComponentID(yuv)));
+#endif
       const Int offsetScalingFactor = bUseHighPrecisionPredictionWeighting ? 1 : (1 << (bitDepth-8));
 
@@ -283,13 +293,25 @@
   if( iRefIdx0 >= 0 && iRefIdx1 >= 0 )
   {
-    addWeightBi(pcYuvSrc0, pcYuvSrc1, uiPartIdx, iWidth, iHeight, pwp0, pwp1, rpcYuvDst );
+#if SVC_EXTENSION
+    addWeightBi(pcYuvSrc0, pcYuvSrc1, pcCU->getSlice()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp0, pwp1, rpcYuvDst );
+#else
+    addWeightBi(pcYuvSrc0, pcYuvSrc1, pcCU->getSlice()->getSPS()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp0, pwp1, rpcYuvDst );
+#endif
   }
   else if ( iRefIdx0 >= 0 && iRefIdx1 <  0 )
   {
-    addWeightUni( pcYuvSrc0, uiPartIdx, iWidth, iHeight, pwp0, rpcYuvDst );
+#if SVC_EXTENSION
+    addWeightUni( pcYuvSrc0, pcCU->getSlice()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp0, rpcYuvDst );
+#else
+    addWeightUni( pcYuvSrc0, pcCU->getSlice()->getSPS()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp0, rpcYuvDst );
+#endif
   }
   else if ( iRefIdx0 <  0 && iRefIdx1 >= 0 )
   {
-    addWeightUni( pcYuvSrc1, uiPartIdx, iWidth, iHeight, pwp1, rpcYuvDst );
+#if SVC_EXTENSION
+    addWeightUni( pcYuvSrc1, pcCU->getSlice()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp1, rpcYuvDst );
+#else
+    addWeightUni( pcYuvSrc1, pcCU->getSlice()->getSPS()->getBitDepths(), uiPartIdx, iWidth, iHeight, pwp1, rpcYuvDst );
+#endif
   }
   else
@@ -327,4 +349,8 @@
     getWpScaling(pcCU, -1, iRefIdx, pwpTmp, pwp);
   }
-  addWeightUni( pcYuvSrc, uiPartAddr, iWidth, iHeight, pwp, pcYuvPred );
-}
+#if SVC_EXTENSION
+  addWeightUni( pcYuvSrc, pcCU->getSlice()->getBitDepths(), uiPartAddr, iWidth, iHeight, pwp, pcYuvPred );
+#else
+  addWeightUni( pcYuvSrc, pcCU->getSlice()->getSPS()->getBitDepths(), uiPartAddr, iWidth, iHeight, pwp, pcYuvPred );
+#endif
+}
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1287)
@@ -63,4 +63,5 @@
   Void addWeightBi(             const TComYuv              *pcYuvSrc0,
                                 const TComYuv              *pcYuvSrc1,
+                                const BitDepths            &bitDepths,
                                 const UInt                  iPartUnitIdx,
                                 const UInt                  uiWidth,
@@ -72,4 +73,5 @@
 
   Void  addWeightUni(           const TComYuv        *const pcYuvSrc0,
+                                const BitDepths            &bitDepths,
                                 const UInt                  iPartUnitIdx,
                                 const UInt                  uiWidth,
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.cpp	(revision 1287)
@@ -278,5 +278,5 @@
 
 
-Void TComYuv::addClip( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt uiTrUnitIdx, const UInt uiPartSize )
+Void TComYuv::addClip( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt uiTrUnitIdx, const UInt uiPartSize, const BitDepths &clipBitDepths )
 {
   for(Int chan=0; chan<getNumberValidComponents(); chan++)
@@ -293,7 +293,7 @@
     const UInt iSrc1Stride = pcYuvSrc1->getStride(ch);
     const UInt iDstStride  = getStride(ch);
-    const Int clipbd = g_bitDepth[toChannelType(ch)];
+    const Int clipbd = clipBitDepths.recon[toChannelType(ch)];
 #if O0043_BEST_EFFORT_DECODING
-    const Int bitDepthDelta = g_bitDepthInStream[toChannelType(ch)] - g_bitDepth[toChannelType(ch)];
+    const Int bitDepthDelta = clipBitDepths.stream[toChannelType(ch)] - clipbd;
 #endif
 
@@ -350,5 +350,5 @@
 
 
-Void TComYuv::addAvg( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt iPartUnitIdx, const UInt uiWidth, const UInt uiHeight )
+Void TComYuv::addAvg( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt iPartUnitIdx, const UInt uiWidth, const UInt uiHeight, const BitDepths &clipBitDepths )
 {
   for(Int chan=0; chan<getNumberValidComponents(); chan++)
@@ -362,5 +362,5 @@
     const UInt  iSrc1Stride = pcYuvSrc1->getStride(ch);
     const UInt  iDstStride  = getStride(ch);
-    const Int   clipbd      = g_bitDepth[toChannelType(ch)];
+    const Int   clipbd      = clipBitDepths.recon[toChannelType(ch)];
     const Int   shiftNum    = std::max<Int>(2, (IF_INTERNAL_PREC - clipbd)) + 1;
     const Int   offset      = ( 1 << ( shiftNum - 1 ) ) + 2 * IF_INTERNAL_OFFS;
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComYuv.h	(revision 1287)
@@ -131,5 +131,5 @@
 
   //  Clip(pcYuvSrc0 + pcYuvSrc1) -> m_apiBuf
-  Void         addClip                    ( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt uiTrUnitIdx, const UInt uiPartSize );
+  Void         addClip                    ( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt uiTrUnitIdx, const UInt uiPartSize, const BitDepths &clipBitDepths );
 
   //  pcYuvSrc0 - pcYuvSrc1 -> m_apiBuf
@@ -137,5 +137,5 @@
 
   //  (pcYuvSrc0 + pcYuvSrc1)/2 for YUV partition
-  Void         addAvg                     ( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt iPartUnitIdx, const UInt iWidth, const UInt iHeight );
+  Void         addAvg                     ( const TComYuv* pcYuvSrc0, const TComYuv* pcYuvSrc1, const UInt iPartUnitIdx, const UInt iWidth, const UInt iHeight, const BitDepths &clipBitDepths );
 
   Void         removeHighFreq             ( const TComYuv* pcYuvSrc, const UInt uiPartIdx, const UInt uiWidth, const UInt uiHeight );
Index: /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1287)
@@ -842,4 +842,25 @@
 
 
+struct BitDepths
+{
+#if O0043_BEST_EFFORT_DECODING
+  Int recon[MAX_NUM_CHANNEL_TYPE]; ///< the bit depth used for reconstructing the video
+  Int stream[MAX_NUM_CHANNEL_TYPE];///< the bit depth used indicated in the SPS
+#else
+  Int recon[MAX_NUM_CHANNEL_TYPE]; ///< the bit depth as indicated in the SPS
+#endif
+
+#if SVC_EXTENSION
+  BitDepths()
+  {
+  }
+  BitDepths(Int bitDepthY, Int bitDepthC)
+  {
+    recon[CHANNEL_TYPE_LUMA] = bitDepthY;
+    recon[CHANNEL_TYPE_CHROMA] = bitDepthC;
+  }
+#endif
+};
+
 /// parameters for deblocking filter
 typedef struct _LFCUParam
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1287)
@@ -766,6 +766,6 @@
   READ_UVLC(     uiCode, "bit_depth_luma_minus8" );
 #if O0043_BEST_EFFORT_DECODING
+  pcSPS->setStreamBitDepth(CHANNEL_TYPE_LUMA, 8 + uiCode);
   const UInt forceDecodeBitDepth = pcSPS->getForceDecodeBitDepth();
-  g_bitDepthInStream[CHANNEL_TYPE_LUMA] = 8 + uiCode;
   if (forceDecodeBitDepth != 0)
   {
@@ -774,8 +774,8 @@
 #endif
   assert(uiCode <= 8);
-
   pcSPS->setBitDepth(CHANNEL_TYPE_LUMA, 8 + uiCode);
+
 #if O0043_BEST_EFFORT_DECODING
-  pcSPS->setQpBDOffset(CHANNEL_TYPE_LUMA, (Int) (6*(g_bitDepthInStream[CHANNEL_TYPE_LUMA]-8)) );
+  pcSPS->setQpBDOffset(CHANNEL_TYPE_LUMA, (Int) (6*(pcSPS->getStreamBitDepth(CHANNEL_TYPE_LUMA)-8)) );
 #else
   pcSPS->setQpBDOffset(CHANNEL_TYPE_LUMA, (Int) (6*uiCode) );
@@ -784,5 +784,5 @@
   READ_UVLC( uiCode,    "bit_depth_chroma_minus8" );
 #if O0043_BEST_EFFORT_DECODING
-  g_bitDepthInStream[CHANNEL_TYPE_CHROMA] = 8 + uiCode;
+  pcSPS->setStreamBitDepth(CHANNEL_TYPE_CHROMA, 8 + uiCode);
   if (forceDecodeBitDepth != 0)
   {
@@ -793,5 +793,5 @@
   pcSPS->setBitDepth(CHANNEL_TYPE_CHROMA, 8 + uiCode);
 #if O0043_BEST_EFFORT_DECODING
-  pcSPS->setQpBDOffset(CHANNEL_TYPE_CHROMA,  (Int) (6*(g_bitDepthInStream[CHANNEL_TYPE_CHROMA]-8)) );
+  pcSPS->setQpBDOffset(CHANNEL_TYPE_CHROMA,  (Int) (6*(pcSPS->getStreamBitDepth(CHANNEL_TYPE_CHROMA)-8)) );
 #else
   pcSPS->setQpBDOffset(CHANNEL_TYPE_CHROMA,  (Int) (6*uiCode) );
@@ -1821,8 +1821,5 @@
 
 #if SVC_EXTENSION
-    g_bitDepthLayer[CHANNEL_TYPE_LUMA][pcSlice->getLayerId()] = pcSlice->getBitDepthY();
-    g_bitDepthLayer[CHANNEL_TYPE_CHROMA][pcSlice->getLayerId()] = pcSlice->getBitDepthC();
-
-    assert( pcSlice->getSliceQp() >= -pcSlice->getQpBDOffsetY() );
+    assert( pcSlice->getSliceQp() >= -pcSlice->getQpBDOffset(CHANNEL_TYPE_LUMA) );
 #else    
     assert( pcSlice->getSliceQp() >= -sps->getQpBDOffset(CHANNEL_TYPE_LUMA) );
@@ -2360,5 +2357,5 @@
 
 #if SVC_EXTENSION
-  Int qpBdOffsetY = pcCU->getSlice()->getQpBDOffsetY();
+  Int qpBdOffsetY = pcCU->getSlice()->getQpBDOffset(CHANNEL_TYPE_LUMA);
 #else
   Int qpBdOffsetY = pcCU->getSlice()->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA);
@@ -2483,5 +2480,9 @@
         wp[COMPONENT_Y].iWeight = (iDeltaWeight + (1<<wp[COMPONENT_Y].uiLog2WeightDenom));
         READ_SVLC( wp[COMPONENT_Y].iOffset, iNumRef==0?"luma_offset_l0[i]":"luma_offset_l1[i]" );
-        Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<g_bitDepth[CHANNEL_TYPE_LUMA])/2 : 128;
+#if SVC_EXTENSION
+        Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<pcSlice->getBitDepth(CHANNEL_TYPE_LUMA))/2 : 128;
+#else
+        Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<sps->getBitDepth(CHANNEL_TYPE_LUMA))/2 : 128;
+#endif
         assert( wp[0].iOffset >= -range );
         assert( wp[0].iOffset <   range );
@@ -2496,5 +2497,9 @@
         if ( wp[COMPONENT_Cb].bPresentFlag )
         {
-          Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<g_bitDepth[CHANNEL_TYPE_CHROMA])/2 : 128;
+#if SVC_EXTENSION
+          Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<pcSlice->getBitDepth(CHANNEL_TYPE_CHROMA))/2 : 128;
+#else
+          Int range=sps->getUseHighPrecisionPredictionWeighting() ? (1<<sps->getBitDepth(CHANNEL_TYPE_CHROMA))/2 : 128;
+#endif
           for ( Int j=1 ; j<numValidComp ; j++ )
           {
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1287)
@@ -499,5 +499,9 @@
   if  ( pcCU->getQtRootCbf( 0) )
   {
-    m_ppcYuvReco[uiDepth]->addClip( m_ppcYuvReco[uiDepth], m_ppcYuvResi[uiDepth], 0, pcCU->getWidth( 0 ) );
+#if SVC_EXTENSION
+    m_ppcYuvReco[uiDepth]->addClip( m_ppcYuvReco[uiDepth], m_ppcYuvResi[uiDepth], 0, pcCU->getWidth( 0 ), pcCU->getSlice()->getBitDepths() );
+#else
+    m_ppcYuvReco[uiDepth]->addClip( m_ppcYuvReco[uiDepth], m_ppcYuvResi[uiDepth], 0, pcCU->getWidth( 0 ), pcCU->getSlice()->getSPS()->getBitDepths() );
+#endif
   }
   else
@@ -642,8 +646,12 @@
 #endif
 
+#if SVC_EXTENSION
+  const Int clipbd = pcCU->getSlice()->getBitDepth(toChannelType(compID));
+#else
+  const Int clipbd = pcCU->getSlice()->getSPS()->getBitDepth(toChannelType(compID));
+#endif
 #if O0043_BEST_EFFORT_DECODING
-  const Int bitDepthDelta = g_bitDepthInStream[toChannelType(compID)] - g_bitDepth[toChannelType(compID)];
-#endif
-  const Int clipbd = g_bitDepth[toChannelType(compID)];
+  const Int bitDepthDelta = pcCU->getSlice()->getSPS()->getStreamBitDepth(toChannelType(compID)) - clipbd;
+#endif
 
   if( useCrossComponentPrediction )
@@ -825,5 +833,9 @@
         Pel* piPicReco         = pcCU->getPic()->getPicYuvRec()->getAddr(compID, pcCU->getCtuRsAddr(), pcCU->getZorderIdxInCtu()+uiPartIdx);
   const UInt uiPicStride       = pcCU->getPic()->getPicYuvRec()->getStride(compID);
-  const UInt uiPcmLeftShiftBit = g_bitDepth[toChannelType(compID)] - pcCU->getSlice()->getSPS()->getPCMBitDepth(toChannelType(compID));
+#if SVC_EXTENSION
+  const UInt uiPcmLeftShiftBit = pcCU->getSlice()->getBitDepth(toChannelType(compID)) - pcCU->getSlice()->getSPS()->getPCMBitDepth(toChannelType(compID));
+#else
+  const UInt uiPcmLeftShiftBit = pcCU->getSlice()->getSPS()->getBitDepth(toChannelType(compID)) - pcCU->getSlice()->getSPS()->getPCMBitDepth(toChannelType(compID));
+#endif
 
   for(UInt uiY = 0; uiY < uiHeight; uiY++ )
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 1287)
@@ -63,5 +63,5 @@
 //! \ingroup TLibDecoder
 //! \{
-static Void calcAndPrintHashStatus(TComPicYuv& pic, const SEIDecodedPictureHash* pictureHashSEI);
+static Void calcAndPrintHashStatus(TComPicYuv& pic, const SEIDecodedPictureHash* pictureHashSEI, const BitDepths &bitDepths);
 // ====================================================================================================================
 // Constructor / destructor / initialization / destroy
@@ -246,5 +246,9 @@
       printf ("Warning: Got multiple decoded picture hash SEI messages. Using first.");
     }
-    calcAndPrintHashStatus(*(pcPic->getPicYuvRec()), hash);
+#if SVC_EXTENSION
+    calcAndPrintHashStatus(*(pcPic->getPicYuvRec()), hash, pcSlice->getBitDepths());
+#else
+    calcAndPrintHashStatus(*(pcPic->getPicYuvRec()), hash, pcSlice->getSPS()->getBitDepths());
+#endif
   }
 #if CONFORMANCE_BITSTREAM_MODE
@@ -275,5 +279,5 @@
  *            unk         - no SEI message was available for comparison
  */
-static Void calcAndPrintHashStatus(TComPicYuv& pic, const SEIDecodedPictureHash* pictureHashSEI)
+static Void calcAndPrintHashStatus(TComPicYuv& pic, const SEIDecodedPictureHash* pictureHashSEI, const BitDepths &bitDepths)
 {
   /* calculate MD5sum for entire reconstructed picture */
@@ -289,5 +293,5 @@
         {
           hashType = "MD5";
-          numChar = calcMD5(pic, recon_digest);
+          numChar = calcMD5(pic, recon_digest, bitDepths);
           break;
         }
@@ -295,5 +299,5 @@
         {
           hashType = "CRC";
-          numChar = calcCRC(pic, recon_digest);
+          numChar = calcCRC(pic, recon_digest, bitDepths);
           break;
         }
@@ -301,5 +305,5 @@
         {
           hashType = "Checksum";
-          numChar = calcChecksum(pic, recon_digest);
+          numChar = calcChecksum(pic, recon_digest, bitDepths);
           break;
         }
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1287)
@@ -947,5 +947,5 @@
     UInt uiSign;
 #if SVC_EXTENSION
-    Int qpBdOffsetY = pcCU->getSlice()->getQpBDOffsetY();
+    Int qpBdOffsetY = pcCU->getSlice()->getQpBDOffset(CHANNEL_TYPE_LUMA);
 #else
     Int qpBdOffsetY = pcCU->getSlice()->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA);
@@ -1687,10 +1687,8 @@
 
 Void TDecSbac::parseSAOBlkParam (SAOBlkParam& saoBlkParam
-#if SVC_EXTENSION
-                                , UInt* saoMaxOffsetQVal
-#endif
                                 , Bool* sliceEnabled
                                 , Bool leftMergeAvail
                                 , Bool aboveMergeAvail
+                                , const BitDepths &bitDepths
                                 )
 {
@@ -1727,5 +1725,11 @@
       const ComponentID firstCompOfChType = getFirstComponentOfChannel(toChannelType(compIdx));
       SAOOffset& ctbParam = saoBlkParam[compIdx];
-
+#if O0043_BEST_EFFORT_DECODING
+      const Int bitDepthOrig = bitDepths.stream[toChannelType(compIdx)];
+      const Int forceBitDepthAdjust = bitDepthOrig - bitDepths.recon[toChannelType(compIdx)];
+#else
+      const Int bitDepthOrig = bitDepths.recon[toChannelType(compIdx)];
+#endif
+      const Int maxOffsetQVal=TComSampleAdaptiveOffset::getMaxOffsetQVal(bitDepthOrig);
       if(!sliceEnabled[compIdx])
       {
@@ -1766,21 +1770,8 @@
       if(ctbParam.modeIdc == SAO_MODE_NEW)
       {
-#if O0043_BEST_EFFORT_DECODING
-        Int bitDepthOrig = g_bitDepthInStream[toChannelType(compIdx)];
-        Int forceBitDepthAdjust = bitDepthOrig - g_bitDepth[toChannelType(compIdx)];
-#endif
         Int offset[4];
         for(Int i=0; i< 4; i++)
         {
-#if O0043_BEST_EFFORT_DECODING
-          Int saoMaxOffsetQVal = (1<<(min(bitDepthOrig, MAX_SAO_TRUNCATED_BITDEPTH)-5))-1;
-          parseSaoMaxUvlc(uiSymbol, saoMaxOffsetQVal); //sao_offset_abs
-#else
-#if SVC_EXTENSION
-          parseSaoMaxUvlc(uiSymbol,  saoMaxOffsetQVal[compIdx] ); //sao_offset_abs
-#else
-          parseSaoMaxUvlc(uiSymbol,  g_saoMaxOffsetQVal[compIdx] ); //sao_offset_abs
-#endif
-#endif
+          parseSaoMaxUvlc(uiSymbol, maxOffsetQVal ); //sao_offset_abs
           offset[i] = (Int)uiSymbol;
         }
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecSbac.h	(revision 1287)
@@ -93,10 +93,5 @@
   Void  parseSaoTypeIdx           ( UInt&  ruiVal  );
   Void  parseSaoUflc              ( UInt uiLength, UInt& ruiVal     );
-
-#if SVC_EXTENSION
-  Void parseSAOBlkParam           (SAOBlkParam& saoBlkParam, UInt* saoMaxOffsetQVal, Bool* sliceEnabled, Bool leftMergeAvail, Bool aboveMergeAvail );
-#else
-  Void parseSAOBlkParam           (SAOBlkParam& saoBlkParam, Bool* sliceEnabled, Bool leftMergeAvail, Bool aboveMergeAvail);
-#endif
+  Void parseSAOBlkParam           (SAOBlkParam& saoBlkParam, Bool* sliceEnabled, Bool leftMergeAvail, Bool aboveMergeAvail, const BitDepths &bitDepths);
   Void parseSaoSign               (UInt& val);
 
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1287)
@@ -61,18 +61,9 @@
 }
 
-#if SVC_EXTENSION
-Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder, UInt* saoMaxOffsetQVal)
+Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
 {
   m_pcEntropyDecoder  = pcEntropyDecoder;
   m_pcCuDecoder       = pcCuDecoder;
-  m_saoMaxOffsetQVal  = saoMaxOffsetQVal;
-}
-#else
-Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
-{
-  m_pcEntropyDecoder  = pcEntropyDecoder;
-  m_pcCuDecoder       = pcCuDecoder;
-}
-#endif
+}
 
 Void TDecSlice::decompressSlice(TComInputBitstream** ppcSubstreams, TComPic* pcPic, TDecSbac* pcSbacDecoder)
@@ -211,8 +202,8 @@
         }
 #if SVC_EXTENSION
-        pcSbacDecoder->parseSAOBlkParam( saoblkParam, m_saoMaxOffsetQVal, sliceEnabled, leftMergeAvail, aboveMergeAvail);
+        pcSbacDecoder->parseSAOBlkParam( saoblkParam, sliceEnabled, leftMergeAvail, aboveMergeAvail, pcSlice->getBitDepths());
 #else
-        pcSbacDecoder->parseSAOBlkParam( saoblkParam, sliceEnabled, leftMergeAvail, aboveMergeAvail);
-#endif      
+        pcSbacDecoder->parseSAOBlkParam( saoblkParam, sliceEnabled, leftMergeAvail, aboveMergeAvail, pcSlice->getSPS()->getBitDepths());
+#endif
       }
     }
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h	(revision 1286)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h	(revision 1287)
@@ -77,9 +77,5 @@
   virtual ~TDecSlice();
   
-#if SVC_EXTENSION  
-  Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder, UInt* saoMaxOffsetQVal );
-#else
   Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder );
-#endif
   Void  create            ();
   Void  destroy           ();
